/****************************************************************
 * PURPOSE: To serve as a platform for simple Graphics projects
 * DATE:	2005 05 13 (Adapted from Edmund Lee 2004 05 08)
 * DATE:	2008 02 02 (Palette adapted from Brendan Briggs 0607
 ****************************************************************/
import java.util.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.lang.Thread;
import java.awt.image.BufferedImage;
import java.io.File;


/*
 * Creates a window (JFrame) to display the Map
 */
public class NewtonMap extends JFrame {
  int width = 200;
  int height = 200;
  double xmax = 2.0;
  double ymax = 2.0;
  int degree;
  // place HashMap definition here...


  public NewtonMap(int d) {
    super("Newton's Method for z^"+d+"-1.");
    degree = d;
    // build the HashMap here...
 
 
 
 
     // execute the content
    getContentPane().add(new Content(width, height, newtonMap));
    // setup the frame 	
    setBounds(0, 0, width, height + 25);
    setVisible(true);
  }

  public static void main(String[] args) {
    Scanner kbd = new Scanner(System.in);

    System.out.print("Enter the degree n of the function z^n-1 (3<=n<=6): ");
    int degree = kbd.nextInt();
    NewtonMap platform = new NewtonMap(degree);

    platform.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  }
}


// inner Content class
class Content extends JPanel {
  final int WIDTH;
  final int HEIGHT;
  int zoomLevel;
  // provide an instance field to store the HashMap

  Palette palette;


  public Content(int w, int h , ????) {
    super();
    WIDTH = w;
    HEIGHT = h;
    palette = new Palette();
  }
	
  /*
   * Captures the picure of the fractal
   */
  public void screenCapture() {
    try {
      Robot robot = new Robot();
      BufferedImage screenShot = robot.createScreenCapture(
          new Rectangle(3, 29, WIDTH - 6, HEIGHT - 7));
      File file = new File("DArcy_" + zoomLevel + ".jpg");

      javax.imageio.ImageIO.write(screenShot, "JPG", file);
    } catch (Exception e) {
      System.out.println("Exception found: " + e);
    }
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    Graphics2D g2 = (Graphics2D) g;
    int col, row;
	// access the HashMap here and draw pixels...

	
  }
}


// inner Palette class
class Palette {

  Color[] palette;
  private int PALETTESIZE = 255;
  public Palette() {
    Random random = new Random();
		
    palette = new Color[PALETTESIZE + 1];
    double factor = PALETTESIZE / Math.log(PALETTESIZE);
    int level;

    for (int n = 0; n < PALETTESIZE; n++) {
      level = (int) (factor * Math.log(n + 1));
      palette[n] = new Color(PALETTESIZE - level, PALETTESIZE - level,
          PALETTESIZE - level);
    }
  }
	
  // accessor method...
  public Color getColor(int i) {
    return palette[i];
  }
}
